#include <stdio.h>

#include "bankaccount.h"

BankAccount::BankAccount(int d) {
    dollars_ = d;
    printf("[CPP] BankAccount::BankAccount(%d), dollars = %d\n", d, dollars_);
}
int BankAccount::dollars() {
    printf("[CPP] BankAccount::dollarst(), dollars = %d\n", dollars_);
    return dollars_;
}
void BankAccount::set_dollars(int d) {
    dollars_ = d;
    printf("[CPP] BankAccount::set_dollars(%d), dollars = %d\n", d, dollars_);
}
void BankAccount::deposit(int d) {
    dollars_ += d;
    printf("[CPP] BankAccount::deposit(%d), dollars = %d\n", d, dollars_);
}
void BankAccount::withdraw(int d) {
    dollars_ -= d;
    printf("[CPP] BankAccount::withdraw(%d), dollars = %d\n", d, dollars_);
}

#ifdef TEST
#include <stdio.h>

extern "C" {
    void* _Znwj(int size);
    void _ZN11BankAccountC1Ei(void* o, int i);
    int _ZN11BankAccount7dollarsEv(void* o);
    void _ZdlPv(void* o);

    extern void* __dso_handle;
}

int main() {
    BankAccount* ba = new BankAccount(200);
    printf("%d\n", ba->dollars());
    delete ba;

    ba = (BankAccount*)_Znwj(sizeof(BankAccount));
    _ZN11BankAccountC1Ei(ba, 200);
    printf("%d\n", _ZN11BankAccount7dollarsEv(ba));
    _ZdlPv(ba);

    printf("%x\n", __dso_handle);

    return 0;
}
#endif
